local BaikItemLevel = LibStub("AceAddon-3.0"):GetAddon("BaikItemLevel")
local ItemUpgradeInfo = LibStub("LibItemUpgradeInfo-1.0")
local ItemHelper = {}

-- Add Module to Addon
BaikItemLevel.ItemHelper = ItemHelper

-- Constants
local PLAYER = "player"

-- Private Methods
function ValueToSteps(num, lower, upper, steps)
    -- Clamp number
    local numClamped = math.max(lower, math.min(upper, num))
    local range = upper - lower

    return math.floor((steps * (numClamped - lower)) / range)
end

function GetItemLevel(link)
    local hasItem = itemLink ~= nil
    local itemLevel = hasItem and ItemUpgradeInfo:GetUpgradedItemLevel(itemLink) or nil

    return itemLevel, hasItem
end

-- ItemHelper API
function ItemHelper:GetPlayerInventorySlotLevel(slot, unit)
    local itemLink = GetInventoryItemLink(unit or PLAYER, slot)
    local hasItem = itemLink ~= nil
    local itemLevel = hasItem and ItemUpgradeInfo:GetUpgradedItemLevel(itemLink) or nil

    return itemLevel, hasItem
end

function ItemHelper:GetBagSlotLevel(container, slot)
    local itemLink = GetContainerItemLink(container, slot)
    local hasItem = itemLink ~= nil
    local itemLevel = hasItem and ItemUpgradeInfo:GetUpgradedItemLevel(itemLink) or nil

    return itemLevel, hasItem
end

function ItemHelper:GetQualityColor(itemLevel)
    local avgItemLevel = select(2, GetAverageItemLevel())
    local deltaItemLevel = itemLevel - avgItemLevel

    return ValueToSteps(deltaItemLevel, BaikItemLevel.db.profile.colorLevelMin,
                BaikItemLevel.db.profile.colorLevelMax, 6)
end
